
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Inventory_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.create(
            {
                id: data.id || undefined,
        
        on_hand_quantity: data.on_hand_quantity
        ||
        null
            ,
            
        reorder_point_quantity: data.reorder_point_quantity
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await inventory_items.setProduct( data.product || null, {
            transaction,
        });
        
        await inventory_items.setProduct_variant( data.product_variant || null, {
            transaction,
        });
        
        await inventory_items.setLocation( data.location || null, {
            transaction,
        });
        
        await inventory_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return inventory_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const inventory_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                on_hand_quantity: item.on_hand_quantity
            ||
            null
            ,
            
                reorder_point_quantity: item.reorder_point_quantity
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const inventory_items = await db.inventory_items.bulkCreate(inventory_itemsData, { transaction });

        // For each item created, replace relation files
        

        return inventory_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const inventory_items = await db.inventory_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.on_hand_quantity !== undefined) updatePayload.on_hand_quantity = data.on_hand_quantity;
        
        
        if (data.reorder_point_quantity !== undefined) updatePayload.reorder_point_quantity = data.reorder_point_quantity;
        
        
        updatePayload.updatedById = currentUser.id;

        await inventory_items.update(updatePayload, {transaction});

        
        
        if (data.product !== undefined) {
            await inventory_items.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.product_variant !== undefined) {
            await inventory_items.setProduct_variant(
              
              data.product_variant,
              
              { transaction }
            );
        }
        
        if (data.location !== undefined) {
            await inventory_items.setLocation(
              
              data.location,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await inventory_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return inventory_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of inventory_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of inventory_items) {
                await record.destroy({transaction});
            }
        });


        return inventory_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findByPk(id, options);

        await inventory_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await inventory_items.destroy({
            transaction
        });

        return inventory_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findOne(
            { where },
            { transaction },
        );

        if (!inventory_items) {
            return inventory_items;
        }

        const output = inventory_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.inventory_adjustments_inventory_item = await inventory_items.getInventory_adjustments_inventory_item({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.product = await inventory_items.getProduct({
            transaction
        });
        
        
        output.product_variant = await inventory_items.getProduct_variant({
            transaction
        });
        
        
        output.location = await inventory_items.getLocation({
            transaction
        });
        
        
        output.organizations = await inventory_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              product_name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.product_variants,
        as: 'product_variant',
        
        where: filter.product_variant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product_variant.split('|').map(term => Utils.uuid(term)) } },
            {
              variant_name: {
                [Op.or]: filter.product_variant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.locations,
        as: 'location',
        
        where: filter.location ? {
          [Op.or]: [
            { id: { [Op.in]: filter.location.split('|').map(term => Utils.uuid(term)) } },
            {
              location_name: {
                [Op.or]: filter.location.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.on_hand_quantityRange) {
                const [start, end] = filter.on_hand_quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    on_hand_quantity: {
                    ...where.on_hand_quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    on_hand_quantity: {
                    ...where.on_hand_quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reorder_point_quantityRange) {
                const [start, end] = filter.reorder_point_quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reorder_point_quantity: {
                    ...where.reorder_point_quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reorder_point_quantity: {
                    ...where.reorder_point_quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.inventory_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'inventory_items',
                        'on_hand_quantity',
                        query,
                    ),
                ],
            };
        }

        const records = await db.inventory_items.findAll({
            attributes: [ 'id', 'on_hand_quantity' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['on_hand_quantity', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.on_hand_quantity,
        }));
    }

    
};

